/*
 *  $Id: asapcache.h,v 1.4 2002/08/22 09:37:22 dreibh Exp $
 *
 * RSerPool implementation.
 *
 * Realized in co-operation between Siemens AG
 * and University of Essen, Institute of Computer Networking Technology.
 *
 * Acknowledgement
 * This work was partially funded by the Bundesministerium fr Bildung und
 * Forschung (BMBF) of the Federal Republic of Germany (Frderkennzeichen 01AK045).
 * The authors alone are responsible for the contents.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * There are two mailinglists available at http://www.sctp.de/rserpool.html
 * which should be used for any discussion related to this implementation.
 *
 * Contact: rsplib-discussion@sctp.de
 *          dreibh@exp-math.uni-essen.de
 *
 * Purpose: ASAP Cache
 *
 */


#ifndef ASAPCACHE_H
#define ASAPCACHE_H


#include "tdtypes.h"
#include "asapinstance.h"


#ifdef __cplusplus
extern "C" {
#endif



/**
  * For internal usage only!
  */
struct PoolElement* asapCacheUpdatePoolElement(struct ASAPInstance* asap,
                                               struct PoolHandle*   poolHandle,
                                               struct PoolElement*  poolElement,
                                               const bool           increment);

/**
  * For internal usage only!
  */
void asapCacheUpdatePool(struct ASAPInstance* asap,
                         struct Pool*         pool);

/**
  * For internal usage only!
  */
void asapCachePurgePoolElement(struct ASAPInstance* asap,
                               struct PoolElement*  poolElement,
                               const bool           decrement);

/**
  * For internal usage only!
  */
void asapCachePurgePool(struct ASAPInstance* asap,
                        struct Pool*         pool);

/**
  * For internal usage only!
  */
void asapCacheMaintenanceTimer(struct Dispatcher* dispatcher,
                               struct Timer*      timer,
                               void*              userData);


#ifdef __cplusplus
}
#endif


#endif
